<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>InequalityType - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="DistanceType.html">DistanceType</a><ul class='members'></ul></li><li><a href="InequalityType.html">InequalityType</a><ul class='members'></ul></li><li><a href="QLearner.html">QLearner</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="QLearner.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#getQtable">getQtable</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doAction">doAction</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doNext">doNext</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doPath">doPath</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#.newQLearner">newQLearner</a></li></ul></li><li><a href="ScalarField.html">ScalarField</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ScalarField.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#set">set</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#erase">erase</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#add">add</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#load">load</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#save">save</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getValues">getValues</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#has">has</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#get">get</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getExtrapolations">getExtrapolations</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getBarycenter">getBarycenter</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getDiameter">getDiameter</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getDistance">getDistance</a></li></ul></li><li><a href="Trajectory.html">Trajectory</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Trajectory.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#addPoint">addPoint</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#addRegion">addRegion</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#add">add</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#getNext">getNext</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#isDone">isDone</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#getPath">getPath</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">InequalityType</h1>
    

    




<section>

<header>
    
        <h2>
        
            InequalityType
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="InequalityType"><span class="type-signature"></span>new InequalityType<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements a type corresponding to a inequality constraint.
<a name="description"></a></p>
<ul>
<li>It considers value pairs with <code>right &gt; left</code> defined by a NumericType <code>ntype</code> of the form:</li>
</ul>
<pre class="prettyprint source"><code>{
 ../..
 left: ntype
 right: ntype
../..
}
</code></pre>
<p>thus a record with two <code>ntype</code> numerical values, where <code>left</code>, <code>right</code>, and <code>ntype</code> is user defined.</p>
<ul>
<li>This type corresponds to value for which <code>right - left = distance</code> which borders the <code>right - left &gt; distance</code> region.
<ul>
<li>Derivation is available in <a href="./distancetype.pdf">this note</a>.</li>
</ul>
</li>
</ul>
<p><a name="specification"></a></p>
<h2>ValueType specification</h2>
<table>
<tr style='border: 1px solid black;'><th> Syntactic projection </th><td>
- Returns a default value, if the underlying numeric type values are undefined.
</td></tr>
<tr style='border: 1px solid black;'><th> Semantic projection  </th><td>
- Returns the closest value wich verifies the distance equality.
</td></tr>
<tr style='border: 1px solid black;'><th> Distance value       </th><td>
- Returns the Euclidean distance between the current value.
</td></tr>
<tr style='border: 1px solid black;'><th> Geodesic path        </th><td>
- The geodesic is calculated using the underlying numeric type precision increment.
</td></tr>
<tr style='border: 1px solid black;'><th> Comparison           </th><td>
- Returns <tt>NAN</tt> no comparison possible for this type.
</td></tr>
<tr style='border: 1px solid black;'><th> Bounds           </th><td>
- Bounds are the underlying numeric type bounds combinations.
</td></tr>
</table>
<p><a name="parameters"></a></p>
<h2>Type parameters</h2>
<h3>General parameter</h3>
<ul>
<li><code>name: ...</code> The type name. By default the type name is &quot;numeric&quot;.</li>
<li><code>ntype: ...</code>: An already defined <a href="https://line.gitlabpages.inria.fr/aide-group/symbolingtype/NumericType.html">NumericType</a>.</li>
<li><code>left: ...</code> The left point field name.</li>
<li><code>right: ...</code> The right point field name.</li>
</ul>
<h3>Numeric type meta-data</h3>
<ul>
<li><code>distance: ...</code> The margin, i.e. the minimal distance between left and right values.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The type parameters.</p>
<ul>
<li>By contract, the type name is a mandatory parameter, default is &quot;value&quot;.
<ul>
<li>Note: Since each name has a different type it used to define hash, less and equal function to index type in containers, it is possible to define <code>std::unordered_map&lt;symboling::Type, T&gt;</code> or <code>std::map&lt;symboling::Type, T&gt;</code>.</li>
</ul>
</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Members</h3>

        
            













        
    

    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>